=== modified file 'drizzled/Makefile.am'
--- drizzled/Makefile.am	2008-11-16 04:24:21 +0000
+++ drizzled/Makefile.am	2008-11-16 05:36:13 +0000
@@ -123,6 +123,8 @@
 		item_subselect.h \
 		item_sum.h \
 		item_timefunc.h \
+		item/cache_row.h \
+		item/type_holder.h \
                 key_map.h \
 		lex.h \
 		lex_symbol.h \
@@ -211,6 +213,8 @@
 		item_subselect.cc \
 		item_sum.cc \
 		item_timefunc.cc \
+		item/cache_row.cc \
+		item/type_holder.cc \
 		key.cc \
                 key_map.cc \
 		lock.cc \

=== added directory 'drizzled/item'
=== modified file 'drizzled/item.cc'
--- drizzled/item.cc	2008-11-15 18:39:51 +0000
+++ drizzled/item.cc	2008-11-16 05:36:13 +0000
@@ -1,17 +1,21 @@
-/* Copyright (C) 2000-2006 MySQL AB
-
-   This program is free software; you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; version 2 of the License.
-
-   This program is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-   GNU General Public License for more details.
-
-   You should have received a copy of the GNU General Public License
-   along with this program; if not, write to the Free Software
-   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
 
 
 #include <drizzled/server_includes.h>
@@ -20,6 +24,8 @@
 #include <drizzled/sql_select.h>
 #include <drizzled/error.h>
 #include <drizzled/show.h>
+#include <drizzled/item/cache_row.h>
+#include <drizzled/item/type_holder.h>
 
 #if defined(CMATH_NAMESPACE)
 using namespace CMATH_NAMESPACE;
@@ -5581,420 +5587,6 @@
 }
 
 
-bool Item_cache_row::allocate(uint32_t num)
-{
-  item_count= num;
-  Session *session= current_session;
-  return (!(values= 
-	    (Item_cache **) session->calloc(sizeof(Item_cache *)*item_count)));
-}
-
-
-bool Item_cache_row::setup(Item * item)
-{
-  example= item;
-  if (!values && allocate(item->cols()))
-    return 1;
-  for (uint32_t i= 0; i < item_count; i++)
-  {
-    Item *el= item->element_index(i);
-    Item_cache *tmp;
-    if (!(tmp= values[i]= Item_cache::get_cache(el)))
-      return 1;
-    tmp->setup(el);
-  }
-  return 0;
-}
-
-
-void Item_cache_row::store(Item * item)
-{
-  null_value= 0;
-  item->bring_value();
-  for (uint32_t i= 0; i < item_count; i++)
-  {
-    values[i]->store(item->element_index(i));
-    null_value|= values[i]->null_value;
-  }
-}
-
-
-void Item_cache_row::illegal_method_call(const char *)
-{
-  assert(0);
-  my_error(ER_OPERAND_COLUMNS, MYF(0), 1);
-  return;
-}
-
-
-bool Item_cache_row::check_cols(uint32_t c)
-{
-  if (c != item_count)
-  {
-    my_error(ER_OPERAND_COLUMNS, MYF(0), c);
-    return 1;
-  }
-  return 0;
-}
-
-
-bool Item_cache_row::null_inside()
-{
-  for (uint32_t i= 0; i < item_count; i++)
-  {
-    if (values[i]->cols() > 1)
-    {
-      if (values[i]->null_inside())
-	return 1;
-    }
-    else
-    {
-      values[i]->update_null_value();
-      if (values[i]->null_value)
-	return 1;
-    }
-  }
-  return 0;
-}
-
-
-void Item_cache_row::bring_value()
-{
-  for (uint32_t i= 0; i < item_count; i++)
-    values[i]->bring_value();
-  return;
-}
-
-
-Item_type_holder::Item_type_holder(Session *session, Item *item)
-  :Item(session, item), enum_set_typelib(0), fld_type(get_real_type(item))
-{
-  assert(item->fixed);
-  maybe_null= item->maybe_null;
-  collation.set(item->collation);
-  get_full_info(item);
-  /* fix variable decimals which always is NOT_FIXED_DEC */
-  if (Field::result_merge_type(fld_type) == INT_RESULT)
-    decimals= 0;
-  prev_decimal_int_part= item->decimal_int_part();
-}
-
-
-/**
-  Return expression type of Item_type_holder.
-
-  @return
-    Item_result (type of internal MySQL expression result)
-*/
-
-Item_result Item_type_holder::result_type() const
-{
-  return Field::result_merge_type(fld_type);
-}
-
-
-/**
-  Find real field type of item.
-
-  @return
-    type of field which should be created to store item value
-*/
-
-enum_field_types Item_type_holder::get_real_type(Item *item)
-{
-  switch(item->type())
-  {
-  case FIELD_ITEM:
-  {
-    /*
-      Item_fields::field_type ask Field_type() but sometimes field return
-      a different type, like for enum/set, so we need to ask real type.
-    */
-    Field *field= ((Item_field *) item)->field;
-    enum_field_types type= field->real_type();
-    if (field->is_created_from_null_item)
-      return DRIZZLE_TYPE_NULL;
-    return type;
-  }
-  case SUM_FUNC_ITEM:
-  {
-    /*
-      Argument of aggregate function sometimes should be asked about field
-      type
-    */
-    Item_sum *item_sum= (Item_sum *) item;
-    if (item_sum->keep_field_type())
-      return get_real_type(item_sum->args[0]);
-    break;
-  }
-  case FUNC_ITEM:
-    if (((Item_func *) item)->functype() == Item_func::GUSERVAR_FUNC)
-    {
-      /*
-        There are work around of problem with changing variable type on the
-        fly and variable always report "string" as field type to get
-        acceptable information for client in send_field, so we make field
-        type from expression type.
-      */
-      switch (item->result_type()) {
-      case STRING_RESULT:
-        return DRIZZLE_TYPE_VARCHAR;
-      case INT_RESULT:
-        return DRIZZLE_TYPE_LONGLONG;
-      case REAL_RESULT:
-        return DRIZZLE_TYPE_DOUBLE;
-      case DECIMAL_RESULT:
-        return DRIZZLE_TYPE_NEWDECIMAL;
-      case ROW_RESULT:
-      default:
-        assert(0);
-        return DRIZZLE_TYPE_VARCHAR;
-      }
-    }
-    break;
-  default:
-    break;
-  }
-  return item->field_type();
-}
-
-/**
-  Find field type which can carry current Item_type_holder type and
-  type of given Item.
-
-  @param session     thread handler
-  @param item    given item to join its parameters with this item ones
-
-  @retval
-    true   error - types are incompatible
-  @retval
-    false  OK
-*/
-
-bool Item_type_holder::join_types(Session *, Item *item)
-{
-  uint32_t max_length_orig= max_length;
-  uint32_t decimals_orig= decimals;
-  fld_type= Field::field_type_merge(fld_type, get_real_type(item));
-  {
-    int item_decimals= item->decimals;
-    /* fix variable decimals which always is NOT_FIXED_DEC */
-    if (Field::result_merge_type(fld_type) == INT_RESULT)
-      item_decimals= 0;
-    decimals= cmax((int)decimals, item_decimals);
-  }
-  if (Field::result_merge_type(fld_type) == DECIMAL_RESULT)
-  {
-    decimals= cmin((int)cmax(decimals, item->decimals), DECIMAL_MAX_SCALE);
-    int precision= cmin(cmax(prev_decimal_int_part, item->decimal_int_part())
-                       + decimals, DECIMAL_MAX_PRECISION);
-    unsigned_flag&= item->unsigned_flag;
-    max_length= my_decimal_precision_to_length(precision, decimals,
-                                               unsigned_flag);
-  }
-
-  switch (Field::result_merge_type(fld_type))
-  {
-  case STRING_RESULT:
-  {
-    const char *old_cs, *old_derivation;
-    uint32_t old_max_chars= max_length / collation.collation->mbmaxlen;
-    old_cs= collation.collation->name;
-    old_derivation= collation.derivation_name();
-    if (collation.aggregate(item->collation, MY_COLL_ALLOW_CONV))
-    {
-      my_error(ER_CANT_AGGREGATE_2COLLATIONS, MYF(0),
-	       old_cs, old_derivation,
-	       item->collation.collation->name,
-	       item->collation.derivation_name(),
-	       "UNION");
-      return(true);
-    }
-    /*
-      To figure out max_length, we have to take into account possible
-      expansion of the size of the values because of character set
-      conversions.
-     */
-    if (collation.collation != &my_charset_bin)
-    {
-      max_length= cmax(old_max_chars * collation.collation->mbmaxlen,
-                      display_length(item) /
-                      item->collation.collation->mbmaxlen *
-                      collation.collation->mbmaxlen);
-    }
-    else
-      set_if_bigger(max_length, display_length(item));
-    break;
-  }
-  case REAL_RESULT:
-  {
-    if (decimals != NOT_FIXED_DEC)
-    {
-      int delta1= max_length_orig - decimals_orig;
-      int delta2= item->max_length - item->decimals;
-      max_length= cmax(delta1, delta2) + decimals;
-      if (fld_type == DRIZZLE_TYPE_DOUBLE && max_length > DBL_DIG + 2) 
-      {
-        max_length= DBL_DIG + 7;
-        decimals= NOT_FIXED_DEC;
-      }
-    }
-    else
-      max_length= DBL_DIG+7;
-    break;
-  }
-  default:
-    max_length= cmax(max_length, display_length(item));
-  };
-  maybe_null|= item->maybe_null;
-  get_full_info(item);
-
-  /* Remember decimal integer part to be used in DECIMAL_RESULT handleng */
-  prev_decimal_int_part= decimal_int_part();
-  return(false);
-}
-
-/**
-  Calculate lenth for merging result for given Item type.
-
-  @param item  Item for length detection
-
-  @return
-    length
-*/
-
-uint32_t Item_type_holder::display_length(Item *item)
-{
-  if (item->type() == Item::FIELD_ITEM)
-    return ((Item_field *)item)->max_disp_length();
-
-  switch (item->field_type())
-  {
-  case DRIZZLE_TYPE_TIMESTAMP:
-  case DRIZZLE_TYPE_TIME:
-  case DRIZZLE_TYPE_DATETIME:
-  case DRIZZLE_TYPE_NEWDATE:
-  case DRIZZLE_TYPE_VARCHAR:
-  case DRIZZLE_TYPE_NEWDECIMAL:
-  case DRIZZLE_TYPE_ENUM:
-  case DRIZZLE_TYPE_BLOB:
-    return 4;
-  case DRIZZLE_TYPE_LONG:
-    return MY_INT32_NUM_DECIMAL_DIGITS;
-  case DRIZZLE_TYPE_DOUBLE:
-    return 53;
-  case DRIZZLE_TYPE_NULL:
-    return 0;
-  case DRIZZLE_TYPE_LONGLONG:
-    return 20;
-  default:
-    assert(0); // we should never go there
-    return 0;
-  }
-}
-
-
-/**
-  Make temporary table field according collected information about type
-  of UNION result.
-
-  @param table  temporary table for which we create fields
-
-  @return
-    created field
-*/
-
-Field *Item_type_holder::make_field_by_type(Table *table)
-{
-  /*
-    The field functions defines a field to be not null if null_ptr is not 0
-  */
-  unsigned char *null_ptr= maybe_null ? (unsigned char*) "" : 0;
-  Field *field;
-
-  switch (fld_type) {
-  case DRIZZLE_TYPE_ENUM:
-    assert(enum_set_typelib);
-    field= new Field_enum((unsigned char *) 0, max_length, null_ptr, 0,
-                          Field::NONE, name,
-                          get_enum_pack_length(enum_set_typelib->count),
-                          enum_set_typelib, collation.collation);
-    if (field)
-      field->init(table);
-    return field;
-  case DRIZZLE_TYPE_NULL:
-    return make_string_field(table);
-  default:
-    break;
-  }
-  return tmp_table_field_from_field_type(table, 0);
-}
-
-
-/**
-  Get full information from Item about enum/set fields to be able to create
-  them later.
-
-  @param item    Item for information collection
-*/
-void Item_type_holder::get_full_info(Item *item)
-{
-  if (fld_type == DRIZZLE_TYPE_ENUM)
-  {
-    if (item->type() == Item::SUM_FUNC_ITEM &&
-        (((Item_sum*)item)->sum_func() == Item_sum::MAX_FUNC ||
-         ((Item_sum*)item)->sum_func() == Item_sum::MIN_FUNC))
-      item = ((Item_sum*)item)->args[0];
-    /*
-      We can have enum/set type after merging only if we have one enum|set
-      field (or MIN|MAX(enum|set field)) and number of NULL fields
-    */
-    assert((enum_set_typelib &&
-                 get_real_type(item) == DRIZZLE_TYPE_NULL) ||
-                (!enum_set_typelib &&
-                 item->type() == Item::FIELD_ITEM &&
-                 (get_real_type(item) == DRIZZLE_TYPE_ENUM) &&
-                 ((Field_enum*)((Item_field *) item)->field)->typelib));
-    if (!enum_set_typelib)
-    {
-      enum_set_typelib= ((Field_enum*)((Item_field *) item)->field)->typelib;
-    }
-  }
-}
-
-
-double Item_type_holder::val_real()
-{
-  assert(0); // should never be called
-  return 0.0;
-}
-
-
-int64_t Item_type_holder::val_int()
-{
-  assert(0); // should never be called
-  return 0;
-}
-
-my_decimal *Item_type_holder::val_decimal(my_decimal *)
-{
-  assert(0); // should never be called
-  return 0;
-}
-
-String *Item_type_holder::val_str(String*)
-{
-  assert(0); // should never be called
-  return 0;
-}
-
-void Item_result_field::cleanup()
-{
-  Item::cleanup();
-  result_field= 0;
-  return;
-}
-
 /**
   Dummy error processor used by default by Name_resolution_context.
 

=== modified file 'drizzled/item.h'
--- drizzled/item.h	2008-11-16 04:24:21 +0000
+++ drizzled/item.h	2008-11-16 05:36:13 +0000
@@ -2058,106 +2058,6 @@
   int save_in_field(Field *field, bool no_conversions);
 };
 
-class Item_cache_row: public Item_cache
-{
-  Item_cache  **values;
-  uint32_t item_count;
-  bool save_array;
-public:
-  Item_cache_row()
-    :Item_cache(), values(0), item_count(2), save_array(0) {}
-  
-  /*
-    'allocate' used only in row transformer, to preallocate space for row 
-    cache.
-  */
-  bool allocate(uint32_t num);
-  /*
-    'setup' is needed only by row => it not called by simple row subselect
-    (only by IN subselect (in subselect optimizer))
-  */
-  bool setup(Item *item);
-  void store(Item *item);
-  void illegal_method_call(const char *);
-  void make_field(Send_field *)
-  {
-    illegal_method_call((const char*)"make_field");
-  };
-  double val_real()
-  {
-    illegal_method_call((const char*)"val");
-    return 0;
-  };
-  int64_t val_int()
-  {
-    illegal_method_call((const char*)"val_int");
-    return 0;
-  };
-  String *val_str(String *)
-  {
-    illegal_method_call((const char*)"val_str");
-    return 0;
-  };
-  my_decimal *val_decimal(my_decimal *val __attribute__((unused)))
-  {
-    illegal_method_call((const char*)"val_decimal");
-    return 0;
-  };
-
-  enum Item_result result_type() const { return ROW_RESULT; }
-  
-  uint32_t cols() { return item_count; }
-  Item *element_index(uint32_t i) { return values[i]; }
-  Item **addr(uint32_t i) { return (Item **) (values + i); }
-  bool check_cols(uint32_t c);
-  bool null_inside();
-  void bring_value();
-  void keep_array() { save_array= 1; }
-  void cleanup()
-  {
-    Item_cache::cleanup();
-    if (save_array)
-      memset(values, 0, item_count*sizeof(Item**));
-    else
-      values= 0;
-    return;
-  }
-};
-
-
-/*
-  Item_type_holder used to store type. name, length of Item for UNIONS &
-  derived tables.
-
-  Item_type_holder do not need cleanup() because its time of live limited by
-  single SP/PS execution.
-*/
-class Item_type_holder: public Item
-{
-protected:
-  TYPELIB *enum_set_typelib;
-  enum_field_types fld_type;
-
-  void get_full_info(Item *item);
-
-  /* It is used to count decimal precision in join_types */
-  int prev_decimal_int_part;
-public:
-  Item_type_holder(Session*, Item*);
-
-  Item_result result_type() const;
-  enum_field_types field_type() const { return fld_type; };
-  enum Type type() const { return TYPE_HOLDER; }
-  double val_real();
-  int64_t val_int();
-  my_decimal *val_decimal(my_decimal *);
-  String *val_str(String*);
-  bool join_types(Session *session, Item *);
-  Field *make_field_by_type(Table *table);
-  static uint32_t display_length(Item *item);
-  static enum_field_types get_real_type(Item *);
-};
-
 
 class st_select_lex;
 void mark_select_range_as_dependent(Session *session,

=== added file 'drizzled/item/cache_row.cc'
--- drizzled/item/cache_row.cc	1970-01-01 00:00:00 +0000
+++ drizzled/item/cache_row.cc	2008-11-16 05:36:13 +0000
@@ -0,0 +1,183 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include <drizzled/server_includes.h>
+#include <drizzled/error.h>
+
+#include <drizzled/item/cache_row.h>
+
+
+void Item_cache_row::make_field(Send_field *)
+{
+  illegal_method_call((const char*)"make_field");
+}
+
+
+double Item_cache_row::val_real()
+{
+  illegal_method_call((const char*)"val");
+  return 0;
+}
+
+
+int64_t Item_cache_row::val_int()
+{
+  illegal_method_call((const char*)"val_int");
+  return 0;
+}
+
+
+String *Item_cache_row::val_str(String *)
+{
+  illegal_method_call((const char*)"val_str");
+  return 0;
+}
+
+
+my_decimal *Item_cache_row::val_decimal(my_decimal *)
+{
+  illegal_method_call((const char*)"val_decimal");
+  return 0;
+}
+
+
+enum Item_result Item_cache_row::result_type() const
+{
+  return ROW_RESULT;
+}
+
+
+uint32_t Item_cache_row::cols()
+{
+  return item_count;
+}
+
+
+Item *Item_cache_row::element_index(uint32_t i)
+{
+  return values[i];
+}
+
+
+Item **Item_cache_row::addr(uint32_t i)
+{
+  return (Item **) (values + i);
+}
+
+
+bool Item_cache_row::allocate(uint32_t num)
+{
+  item_count= num;
+  Session *session= current_session;
+  return (!(values=
+            (Item_cache **) session->calloc(sizeof(Item_cache *)*item_count)));
+}
+
+
+bool Item_cache_row::setup(Item * item)
+{
+  example= item;
+  if (!values && allocate(item->cols()))
+    return 1;
+  for (uint32_t i= 0; i < item_count; i++)
+  {
+    Item *el= item->element_index(i);
+    Item_cache *tmp;
+    if (!(tmp= values[i]= Item_cache::get_cache(el)))
+      return 1;
+    tmp->setup(el);
+  }
+  return 0;
+}
+
+
+void Item_cache_row::store(Item * item)
+{
+  null_value= 0;
+  item->bring_value();
+  for (uint32_t i= 0; i < item_count; i++)
+  {
+    values[i]->store(item->element_index(i));
+    null_value|= values[i]->null_value;
+  }
+}
+
+
+void Item_cache_row::illegal_method_call(const char *)
+{
+  assert(0);
+  my_error(ER_OPERAND_COLUMNS, MYF(0), 1);
+  return;
+}
+
+
+bool Item_cache_row::check_cols(uint32_t c)
+{
+  if (c != item_count)
+  {
+    my_error(ER_OPERAND_COLUMNS, MYF(0), c);
+    return 1;
+  }
+  return 0;
+}
+
+
+bool Item_cache_row::null_inside()
+{
+  for (uint32_t i= 0; i < item_count; i++)
+  {
+    if (values[i]->cols() > 1)
+    {
+      if (values[i]->null_inside())
+        return 1;
+    }
+    else
+    {
+      values[i]->update_null_value();
+      if (values[i]->null_value)
+        return 1;
+    }
+  }
+  return 0;
+}
+
+
+void Item_cache_row::bring_value()
+{
+  for (uint32_t i= 0; i < item_count; i++)
+    values[i]->bring_value();
+  return;
+}
+
+
+void Item_cache_row::keep_array()
+{
+  save_array= 1;
+}
+
+
+void Item_cache_row::cleanup()
+{
+  Item_cache::cleanup();
+  if (save_array)
+    memset(values, 0, item_count*sizeof(Item**));
+  else
+    values= 0;
+  return;
+}

=== added file 'drizzled/item/cache_row.h'
--- drizzled/item/cache_row.h	1970-01-01 00:00:00 +0000
+++ drizzled/item/cache_row.h	2008-11-16 05:36:13 +0000
@@ -0,0 +1,70 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLED_ITEM_CACHE_ROW_H
+#define DRIZZLED_ITEM_CACHE_ROW_H
+
+#include <stdint.h>
+
+class Item_cache;
+class Item;
+class Send_field;
+
+class Item_cache_row: public Item_cache
+{
+  Item_cache  **values;
+  uint32_t item_count;
+  bool save_array;
+public:
+
+  Item_cache_row()
+  :Item_cache(), values(0), item_count(2), save_array(0) {}
+
+  /*
+    'allocate' used only in row transformer, to preallocate space for row
+    cache.
+  */
+  bool allocate(uint32_t num);
+  /*
+    'setup' is needed only by row => it not called by simple row subselect
+    (only by IN subselect (in subselect optimizer))
+  */
+  bool setup(Item *item);
+  void store(Item *item);
+  void illegal_method_call(const char * method_name);
+  void make_field(Send_field *field);
+  double val_real();
+  int64_t val_int();
+  String *val_str(String *val);
+  my_decimal *val_decimal(my_decimal *val);
+
+  enum Item_result result_type() const;
+
+  uint32_t cols();
+  Item *element_index(uint32_t i);
+  Item **addr(uint32_t i);
+  bool check_cols(uint32_t c);
+  bool null_inside();
+  void bring_value();
+  void keep_array();
+  void cleanup();
+
+};
+
+#endif /* DRIZZLED_ITEM_CACHE_ROW_H */

=== added file 'drizzled/item/type_holder.cc'
--- drizzled/item/type_holder.cc	1970-01-01 00:00:00 +0000
+++ drizzled/item/type_holder.cc	2008-11-16 05:36:13 +0000
@@ -0,0 +1,302 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include <drizzled/server_includes.h>
+#include <drizzled/error.h>
+#include <drizzled/item/type_holder.h>
+
+Item_type_holder::Item_type_holder(Session *session, Item *item)
+  :Item(session, item), enum_set_typelib(0), fld_type(get_real_type(item))
+{
+  assert(item->fixed);
+  maybe_null= item->maybe_null;
+  collation.set(item->collation);
+  get_full_info(item);
+  /* fix variable decimals which always is NOT_FIXED_DEC */
+  if (Field::result_merge_type(fld_type) == INT_RESULT)
+    decimals= 0;
+  prev_decimal_int_part= item->decimal_int_part();
+}
+
+
+Item_result Item_type_holder::result_type() const
+{
+  return Field::result_merge_type(fld_type);
+}
+
+
+enum_field_types Item_type_holder::get_real_type(Item *item)
+{
+  switch(item->type())
+  {
+  case FIELD_ITEM:
+  {
+    /*
+      Item_fields::field_type ask Field_type() but sometimes field return
+      a different type, like for enum/set, so we need to ask real type.
+    */
+    Field *field= ((Item_field *) item)->field;
+    enum_field_types type= field->real_type();
+    if (field->is_created_from_null_item)
+      return DRIZZLE_TYPE_NULL;
+    return type;
+  }
+  case SUM_FUNC_ITEM:
+  {
+    /*
+      Argument of aggregate function sometimes should be asked about field
+      type
+    */
+    Item_sum *item_sum= (Item_sum *) item;
+    if (item_sum->keep_field_type())
+      return get_real_type(item_sum->args[0]);
+    break;
+  }
+  case FUNC_ITEM:
+    if (((Item_func *) item)->functype() == Item_func::GUSERVAR_FUNC)
+    {
+      /*
+        There are work around of problem with changing variable type on the
+        fly and variable always report "string" as field type to get
+        acceptable information for client in send_field, so we make field
+        type from expression type.
+      */
+      switch (item->result_type()) {
+      case STRING_RESULT:
+        return DRIZZLE_TYPE_VARCHAR;
+      case INT_RESULT:
+        return DRIZZLE_TYPE_LONGLONG;
+      case REAL_RESULT:
+        return DRIZZLE_TYPE_DOUBLE;
+      case DECIMAL_RESULT:
+        return DRIZZLE_TYPE_NEWDECIMAL;
+      case ROW_RESULT:
+      default:
+        assert(0);
+        return DRIZZLE_TYPE_VARCHAR;
+      }
+    }
+    break;
+  default:
+    break;
+  }
+  return item->field_type();
+}
+
+
+bool Item_type_holder::join_types(Session *, Item *item)
+{
+  uint32_t max_length_orig= max_length;
+  uint32_t decimals_orig= decimals;
+  fld_type= Field::field_type_merge(fld_type, get_real_type(item));
+  {
+    int item_decimals= item->decimals;
+    /* fix variable decimals which always is NOT_FIXED_DEC */
+    if (Field::result_merge_type(fld_type) == INT_RESULT)
+      item_decimals= 0;
+    decimals= cmax((int)decimals, item_decimals);
+  }
+  if (Field::result_merge_type(fld_type) == DECIMAL_RESULT)
+  {
+    decimals= cmin((int)cmax(decimals, item->decimals), DECIMAL_MAX_SCALE);
+    int precision= cmin(cmax(prev_decimal_int_part, item->decimal_int_part())
+                       + decimals, DECIMAL_MAX_PRECISION);
+    unsigned_flag&= item->unsigned_flag;
+    max_length= my_decimal_precision_to_length(precision, decimals,
+                                               unsigned_flag);
+  }
+
+  switch (Field::result_merge_type(fld_type))
+  {
+  case STRING_RESULT:
+  {
+    const char *old_cs, *old_derivation;
+    uint32_t old_max_chars= max_length / collation.collation->mbmaxlen;
+    old_cs= collation.collation->name;
+    old_derivation= collation.derivation_name();
+    if (collation.aggregate(item->collation, MY_COLL_ALLOW_CONV))
+    {
+      my_error(ER_CANT_AGGREGATE_2COLLATIONS, MYF(0),
+               old_cs, old_derivation,
+               item->collation.collation->name,
+               item->collation.derivation_name(),
+               "UNION");
+      return(true);
+    }
+    /*
+      To figure out max_length, we have to take into account possible
+      expansion of the size of the values because of character set
+      conversions.
+     */
+    if (collation.collation != &my_charset_bin)
+    {
+      max_length= cmax(old_max_chars * collation.collation->mbmaxlen,
+                      display_length(item) /
+                      item->collation.collation->mbmaxlen *
+                      collation.collation->mbmaxlen);
+    }
+    else
+      set_if_bigger(max_length, display_length(item));
+    break;
+  }
+  case REAL_RESULT:
+  {
+    if (decimals != NOT_FIXED_DEC)
+    {
+      int delta1= max_length_orig - decimals_orig;
+      int delta2= item->max_length - item->decimals;
+      max_length= cmax(delta1, delta2) + decimals;
+      if (fld_type == DRIZZLE_TYPE_DOUBLE && max_length > DBL_DIG + 2)
+      {
+        max_length= DBL_DIG + 7;
+        decimals= NOT_FIXED_DEC;
+      }
+    }
+    else
+      max_length= DBL_DIG+7;
+    break;
+  }
+  default:
+    max_length= cmax(max_length, display_length(item));
+  };
+  maybe_null|= item->maybe_null;
+  get_full_info(item);
+
+  /* Remember decimal integer part to be used in DECIMAL_RESULT handleng */
+  prev_decimal_int_part= decimal_int_part();
+  return(false);
+}
+
+
+uint32_t Item_type_holder::display_length(Item *item)
+{
+  if (item->type() == Item::FIELD_ITEM)
+    return ((Item_field *)item)->max_disp_length();
+
+  switch (item->field_type())
+  {
+  case DRIZZLE_TYPE_TIMESTAMP:
+  case DRIZZLE_TYPE_TIME:
+  case DRIZZLE_TYPE_DATETIME:
+  case DRIZZLE_TYPE_NEWDATE:
+  case DRIZZLE_TYPE_VARCHAR:
+  case DRIZZLE_TYPE_NEWDECIMAL:
+  case DRIZZLE_TYPE_ENUM:
+  case DRIZZLE_TYPE_BLOB:
+    return 4;
+  case DRIZZLE_TYPE_LONG:
+    return MY_INT32_NUM_DECIMAL_DIGITS;
+  case DRIZZLE_TYPE_DOUBLE:
+    return 53;
+  case DRIZZLE_TYPE_NULL:
+    return 0;
+  case DRIZZLE_TYPE_LONGLONG:
+    return 20;
+  default:
+    assert(0); // we should never go there
+    return 0;
+  }
+}
+
+
+Field *Item_type_holder::make_field_by_type(Table *table)
+{
+  /*
+    The field functions defines a field to be not null if null_ptr is not 0
+  */
+  unsigned char *null_ptr= maybe_null ? (unsigned char*) "" : 0;
+  Field *field;
+
+  switch (fld_type) {
+  case DRIZZLE_TYPE_ENUM:
+    assert(enum_set_typelib);
+    field= new Field_enum((unsigned char *) 0, max_length, null_ptr, 0,
+                          Field::NONE, name,
+                          get_enum_pack_length(enum_set_typelib->count),
+                          enum_set_typelib, collation.collation);
+    if (field)
+      field->init(table);
+    return field;
+  case DRIZZLE_TYPE_NULL:
+    return make_string_field(table);
+  default:
+    break;
+  }
+  return tmp_table_field_from_field_type(table, 0);
+}
+
+
+void Item_type_holder::get_full_info(Item *item)
+{
+  if (fld_type == DRIZZLE_TYPE_ENUM)
+  {
+    if (item->type() == Item::SUM_FUNC_ITEM &&
+        (((Item_sum*)item)->sum_func() == Item_sum::MAX_FUNC ||
+         ((Item_sum*)item)->sum_func() == Item_sum::MIN_FUNC))
+      item = ((Item_sum*)item)->args[0];
+    /*
+      We can have enum/set type after merging only if we have one enum|set
+      field (or MIN|MAX(enum|set field)) and number of NULL fields
+    */
+    assert((enum_set_typelib &&
+                 get_real_type(item) == DRIZZLE_TYPE_NULL) ||
+                (!enum_set_typelib &&
+                 item->type() == Item::FIELD_ITEM &&
+                 (get_real_type(item) == DRIZZLE_TYPE_ENUM) &&
+                 ((Field_enum*)((Item_field *) item)->field)->typelib));
+    if (!enum_set_typelib)
+    {
+      enum_set_typelib= ((Field_enum*)((Item_field *) item)->field)->typelib;
+    }
+  }
+}
+
+
+double Item_type_holder::val_real()
+{
+  assert(0); // should never be called
+  return 0.0;
+}
+
+
+int64_t Item_type_holder::val_int()
+{
+  assert(0); // should never be called
+  return 0;
+}
+
+my_decimal *Item_type_holder::val_decimal(my_decimal *)
+{
+  assert(0); // should never be called
+  return 0;
+}
+
+String *Item_type_holder::val_str(String*)
+{
+  assert(0); // should never be called
+  return 0;
+}
+
+void Item_result_field::cleanup()
+{
+  Item::cleanup();
+  result_field= 0;
+  return;
+}
+

=== added file 'drizzled/item/type_holder.h'
--- drizzled/item/type_holder.h	1970-01-01 00:00:00 +0000
+++ drizzled/item/type_holder.h	2008-11-16 05:36:13 +0000
@@ -0,0 +1,115 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLED_ITEM_TYPE_HOLDER_H
+#define DRIZZLED_ITEM_TYPE_HOLDER_H
+
+typedef struct st_typelib TYPELIB;
+class String;
+class my_decimal;
+class Session;
+class Item;
+
+/*
+  Item_type_holder used to store type. name, length of Item for UNIONS &
+  derived tables.
+
+  Item_type_holder do not need cleanup() because its time of live limited by
+  single SP/PS execution.
+*/
+class Item_type_holder: public Item
+{
+protected:
+  TYPELIB *enum_set_typelib;
+  enum_field_types fld_type;
+
+  /**
+    Get full information from Item about enum/set fields to be able to create
+    them later.
+
+    @param item    Item for information collection
+  */
+  void get_full_info(Item *item);
+
+  /* It is used to count decimal precision in join_types */
+  int prev_decimal_int_part;
+public:
+  Item_type_holder(Session *session, Item *item);
+
+  /**
+     Return expression type of Item_type_holder.
+
+     @return
+     Item_result (type of internal Drizzle expression result)
+  */
+  Item_result result_type() const;
+
+  enum_field_types field_type() const { return fld_type; };
+  enum Type type() const { return TYPE_HOLDER; }
+  double val_real();
+  int64_t val_int();
+  my_decimal *val_decimal(my_decimal *val);
+  String *val_str(String* val);
+
+  /**
+    Find field type which can carry current Item_type_holder type and
+    type of given Item.
+
+    @param session     thread handler
+    @param item    given item to join its parameters with this item ones
+
+    @retval
+      true   error - types are incompatible
+    @retval
+      false  OK
+  */
+  bool join_types(Session *session, Item *item);
+
+  /**
+    Make temporary table field according collected information about type
+    of UNION result.
+
+    @param table  temporary table for which we create fields
+
+    @return
+      created field
+  */
+  Field *make_field_by_type(Table *table);
+
+  /**
+    Calculate lenth for merging result for given Item type.
+
+    @param item  Item for length detection
+
+    @return
+      length
+  */
+  static uint32_t display_length(Item *item);
+
+  /**
+     Find real field type of item.
+
+     @return
+     type of field which should be created to store item value
+  */
+  static enum_field_types get_real_type(Item *item);
+};
+
+
+#endif /* DRIZZLED_ITEM_TYPE_HOLDER_H */

=== modified file 'drizzled/sql_union.cc'
--- drizzled/sql_union.cc	2008-11-04 13:22:55 +0000
+++ drizzled/sql_union.cc	2008-11-16 05:36:13 +0000
@@ -20,6 +20,7 @@
 #include <drizzled/server_includes.h>
 #include <drizzled/sql_select.h>
 #include <drizzled/error.h>
+#include <drizzled/item/type_holder.h>
 
 bool mysql_union(Session *session, LEX *, select_result *result,
                  SELECT_LEX_UNIT *unit, ulong setup_tables_done_option)

